/***************************
* rctest.c
*
* Test code for RCPulse code
****************************/
#include <p30fxxxx.h>
#include "rcpulse.h"

_FOSC(CSW_FSCM_OFF & FRC_PLL16);    /* Internal Osc PLLx16 = 30MIP */
_FWDT(WDT_OFF);                     /* Watchdog Off */
_FBORPOR(PBOR_OFF & MCLR_EN);       /* Brownout Disabled - MCLR Enabled */
_FGS(CODE_PROT_OFF);                /* Code Protect OFF */

void DelayMs(int dly)
{
 unsigned int x;

 while(dly >0)
 {
  x=5000;  
  while(--x)continue;  
  dly--;
 }
}

int main(void)
{
 unsigned int pos,tmp;
  
 ADPCFG=0xFFFF; /* All to Digital pins! */
 
 RCPulse_Init();
 
 while(1)
 {
  for(pos=0;pos<256;pos++)
  {
   RCPulse(pos);
   while(RCDone()==0);
   DelayMs(20);   /* 20mS delay min between pulses */
  }

  DelayMs(100);
  

  for(pos=255;pos>0;pos-=5)
  {
   RCPulse(pos);
   while(RCDone()==0);
   DelayMs(20);   /* 20mS delay min between pulses */
  }

  DelayMs(100);

  /* Bounce between extreams and eventually end up in the middle*/
  for(pos=0;pos<128;pos+=8)
  {
   for(tmp=0;tmp<50;tmp++)
   {
    RCPulse(pos+128);
    while(RCDone()==0);
    DelayMs(10);
   }
   for(tmp=0;tmp<50;tmp++)
   {
    RCPulse(128-pos);
    while(RCDone()==0);
    DelayMs(10);
   }
  }
 }
  
 return(0);	
}
